
// EE231002 Lab07. Magic Square
// 108061112, 林靖
// SIZEov. 2, 2019

#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define SIZE 4
#define UNFILLED 0

typedef int BOOL;

int g_count;
int g_array[SIZE][SIZE];
int g_target_sum;
void solve_unfilled_or_print(void);


int main(void)
{
	int i, j;

	for (i = 0; i < SIZE; i++) {
		for (j = 0; j < SIZE; j++) {
			scanf("%d", &g_array[i][j]);
		}
	}
	g_target_sum = SIZE * (SIZE * SIZE + 1) / 2;
	solve_unfilled_or_print();
	printf("Number of solutions found: %d\n", g_count);
	return 0;
}


void solve_unfilled_or_print(void)
{
	BOOL found_unfilled;
	BOOL is_legal;
	int row, column;
	int i, j;
	int guess;
	int sum;

	found_unfilled = FALSE;
	for (row = 0; !found_unfilled && row < SIZE; row++) {
		for (column = 0; !found_unfilled && column < SIZE; column++) {
			if (g_array[row][column] == UNFILLED) {
				found_unfilled = TRUE;
			}
		}
	}
	row--;
	column--;

	if (found_unfilled) {
		for (guess = SIZE * SIZE; guess > 0; guess--) {
			is_legal = TRUE;
			for (i = 0; is_legal && i < SIZE; i++) {
				for (j = 0; is_legal && j < SIZE; j++) {
					if (g_array[i][j] == guess) {
						is_legal = FALSE;
					}
				}
			}
			if (is_legal) {
				g_array[row][column] = guess;
				solve_unfilled_or_print();
				g_array[row][column] = UNFILLED;
			}
		}
	} else {
		is_legal = TRUE;
		if (is_legal) {
			for (i = 0; i < SIZE; i++) {
				sum = 0;
				for (j = 0; j < SIZE; j++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			for (j = 0; j < SIZE; j++) {
				sum = 0;
				for (i = 0; i < SIZE; i++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = 0; i < SIZE; i++, j++) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = SIZE - 1; i < SIZE; i++, j--) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			printf("Solution %d:\n", ++g_count);
			for (i = 0; i < SIZE; i++) {
				for (j = 0; j < SIZE; j++) {
					printf("%4d", g_array[i][j]);
				}
				printf("\n");
			}
			printf("\n");
		}
	}
	return;
}
// EE231002 Lab06. Permutations
// 108061112, 林靖
// Oct. 25, 2019


// EE231002 Lab07. Magic Square
// 108061112, 林靖
// SIZEov. 2, 2019

#include <stdio.h>
#define TRUE 1
#define FALSE 0
#define SIZE 4
#define UNFILLED 0

typedef int BOOL;

int main(void)		// Called at program startup
{
	int i, j, k;
	int temp;		// To swap in step 3, to reverse sequence in step 4
	int g_count;	// Number of permutations generated
	int max_integer;
	int num_of_unfilled;
	int g_array[SIZE][SIZE];
	int unfilled_row[SIZE * SIZE + 1];
	int unfilled_column[SIZE * SIZE + 1];
	int unused_integer[SIZE * SIZE + 1];
	
	max_integer = SIZE * SIZE;
	for (i = 1; i <= max_interger; i++) {
		unused_integer[i] = i;
	}

	num_of_unfilled = 0;
	for (i = 0; i < SIZE; i++) {
		for (j = 0; j < SIZE; j++) {
			scanf("%d", &g_array[i][j]);
			if (g_array[i][j] == UNFILLED) {
				num_of_unfilled++;
				unfilled_row[num_of_unfilled] = i;
				unfilled_column[num_of_unfilled] = j;
			} else {
				unused_integer[g_array[i][j]] = USED;
			}
		}
	}

	for (i = 1; i <= max_integer; i++) {
		for (k = i; !unused_integer[k] && k <= max_integer; k++) ;
		k--;
		unused_integer[i] = unused_integer[k];
		unused_integer[k] = USED;
	}

	g_target_sum = SIZE * (SIZE * SIZE + 1) / 2;

/*	
	for (i = N; i > 0; i--) {	// Initialize the set of integers from 1 to N
		A[N - i] = i;			// In reversed order
	}
*/	

	j = num_of_unfilled;
	while (j >= 0) {			// If j < 0, no such index exists (the end)
		for (i = num_of_unfilled; ++j < --i; ) { // Step 4 to reverse A[j + 1] ~ A[N - 1]
			temp = unused_integer[j];		//
			unused_integer[j] = unused_integer[i];		// Step 4 mirror the elements by reflection
			unusef_integer[i] = temp;		//
		}
		for (i = 1; i <= num_of_unfilled; i ++) {
			g_array[unfilled_row[i]][unfilled_column[i]] = unused_integer[i];
		}
		is_legal = TRUE;
		if (is_legal) {
			for (i = 0; i < SIZE; i++) {
				sum = 0;
				for (j = 0; j < SIZE; j++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			for (j = 0; j < SIZE; j++) {
				sum = 0;
				for (i = 0; i < SIZE; i++) {
					sum += g_array[i][j];
				}
				if (sum != g_target_sum) {
					is_legal = FALSE;
				}
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = 0; i < SIZE; i++, j++) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			sum = 0;
			for (i = 0, j = SIZE - 1; i < SIZE; i++, j--) {
				sum += g_array[i][j];
			}
			if (sum != g_target_sum) {
				is_legal = FALSE;
			}
		}
		if (is_legal) {
			printf("Solution %d:\n", ++g_count);
			for (i = 0; i < SIZE; i++) {
				for (j = 0; j < SIZE; j++) {
					printf("%4d", g_array[i][j]);
				}
				printf("\n");
			}
			printf("\n");
		}
/*
		printf("permutation #%d: ", ++count);	// # of permutations generated
		for (i = 0; i < N; i++) {	// To print out all the elements in A[N]
			printf("%d ", A[i]);	// To print out the permutation
		}
		printf("\n");	// (new line)
*/
		for (j = num_of_unfilled - 1; j && unused_interger[j] > unused_interger[j + 1]; j--) ; // Step 1 find index j
		for (k = num_of_unfukked - 1; unused_interger[j] > unused_integer[k]; k--) ;				  // Step 2 find index k
		temp = unused_integer[j];		//
		unused_integer[j] = unused_integer[k];		// Step 4 mirror the elements by reflection
		unusef_integer[k] = temp;		//
	}
	printf("Number of solutions found: %d\n", g_count);
	return 0;	// Indicates normal program termination
}
